=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2009-03-24 23:19:12 +0000
+++ bzrlib/tests/test_graph.py	2009-05-27 11:04:52 +0000
@@ -661,6 +661,7 @@
         self.assertEqual((set(['e']), set(['f', 'g'])),
                          graph.find_difference('e', 'f'))
 
+
     def test_stacked_parents_provider(self):
         parents1 = _mod_graph.DictParentsProvider({'rev2': ['rev3']})
         parents2 = _mod_graph.DictParentsProvider({'rev1': ['rev4']})
@@ -673,6 +674,35 @@
                          stacked.get_parent_map(['rev2', 'rev2']))
         self.assertEqual({'rev1':['rev4']},
                          stacked.get_parent_map(['rev1', 'rev1']))
+    
+    def test_stacked_parents_provider_overlapping(self):
+        # rev2 is availible in both providers.
+        # 1
+        # |
+        # 2
+        # |\
+        # 3 5
+        # | |
+        # 4 6
+        parents1 = _mod_graph.DictParentsProvider({'rev2':['rev1'],
+                                                   'rev3':['rev2'],
+                                                   'rev4':['rev3']})
+        parents2 = _mod_graph.DictParentsProvider({'rev2':['rev1'],
+                                                   'rev5':['rev2'],
+                                                   'rev6':['rev5']})
+        stacked = _mod_graph._StackedParentsProvider([parents1, parents2])
+        self.assertEqual({'rev2':['rev1'],
+                          'rev3':['rev2'],
+                          'rev4':['rev3'],
+                          'rev5':['rev2'],
+                          'rev6':['rev5'],
+                         },
+                         stacked.get_parent_map(['rev2',
+                                                 'rev3',
+                                                 'rev4',
+                                                 'rev5',
+                                                 'rev6',
+                                                 ]))
 
     def test_iter_topo_order(self):
         graph = self.make_graph(ancestry_1)

